<?php
namespace moonlight\eticket;
class eticket_ajax_validation_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Check user name duplication on usr_id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_name_duplication_edit($p_user_name,$p_user_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user 
			 		WHERE
			 			usr_short_name = '".\U::safe_sql_string($p_user_name)."'
			 		AND 
			 			usr_id != '".\U::safe_sql_string($p_user_id)."'
					AND 
						_rec_status = \"SHOW\"	 
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check user name duplication on usr_short_name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_name_duplication($p_user_name){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user 
			 		WHERE
			 			usr_short_name = '".\U::safe_sql_string($p_user_name)."'
					AND 
						_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check user duplication on usr__ic_no except current user for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_ic_no_duplication_edit($p_user_role,$p_user_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user 
			 		WHERE
			 			usr_new_ic_no = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			usr_id != '".\U::safe_sql_string($p_user_id)."'
					AND 
						 _rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check user duplication on usr_new_ic_no
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_ic_no_duplication($p_user_ic_no){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user 
			 		WHERE
			 			usr_new_ic_no = '".\U::safe_sql_string($p_user_ic_no)."'
					AND 
						_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on user_role
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_role_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user_roles 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on user_role except current role on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_role_duplication_edit($p_user_role,$p_primary_table_id, $p_agency_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "user_roles 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 		AND
			 			agency_id = '".\U::safe_sql_string($p_agency_id)."'
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on agency except current agency on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_duplication_edit($p_user_role,$p_primary_table_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "agency 
			 		WHERE
			 			ag_code = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			ag_id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on locations except current locations on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_duplication_edit($p_user_role,$p_primary_table_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			code = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on agency name except current agency name on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_name_duplication_edit($p_user_role,$p_primary_table_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "agency 
			 		WHERE
			 			ag_name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			ag_id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on location name except current location name on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_name_duplication_edit($p_user_role,$p_primary_table_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on agency code
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "agency  
			 		WHERE
			 			ag_code = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on location code
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			code = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on agency name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_name_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "agency  
			 		WHERE
			 			ag_name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on location name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_name_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on ticket_category code
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_duplication($p_user_role,$p_v_ticket_category_type_text=NULL){
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition("agency");
		$v_ticket_category_type_text = "";
		if( isset($p_v_ticket_category_type_text) && $p_v_ticket_category_type_text != '' ) {
			$v_ticket_category_type_text = " AND category_type_key = '".$p_v_ticket_category_type_text."' ";
		}
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_category 
			 		WHERE
			 			code = '".\U::safe_sql_string($p_user_role)."'
			 			".$v_agency_condition."
			 			".$v_ticket_category_type_text."
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on ticket_category name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_name_duplication($p_user_role,$p_v_ticket_category_type_text=NULL){
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition("agency");
		$v_ticket_category_type_text = "";
		if( isset($p_v_ticket_category_type_text) && $p_v_ticket_category_type_text != '' ) {
			$v_ticket_category_type_text = " AND category_type_key = '".$p_v_ticket_category_type_text."' ";
		}
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_category 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 			".$v_agency_condition."
			 			".$v_ticket_category_type_text."
			 		AND 
			 			_rec_status = \"SHOW\"
		";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on ticket_category code except current category for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_duplication_edit($p_user_role,$p_primary_table_id,$p_v_ticket_category_type_text=NULL){
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition("agency");
		$v_ticket_category_type_text = "";
		if( isset($p_v_ticket_category_type_text) && $p_v_ticket_category_type_text != '' ) {
			$v_ticket_category_type_text = " AND category_type_key = '".$p_v_ticket_category_type_text."' ";
		}
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_category 
			 		WHERE
			 			code = '".\U::safe_sql_string($p_user_role)."'
			 			".$v_agency_condition."
			 			".$v_ticket_category_type_text."
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on ticket_category name except current category for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_name_duplication_edit($p_user_role,$p_primary_table_id,$p_v_ticket_category_type_text=NULL){
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition("agency");
		$v_ticket_category_type_text = "";
		if( isset($p_v_ticket_category_type_text) && $p_v_ticket_category_type_text != '' ) {
			$v_ticket_category_type_text = " AND category_type_key = '".$p_v_ticket_category_type_text."' ";
		}
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_category 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 			".$v_agency_condition."
			 			".$v_ticket_category_type_text."
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on ticket_profile code
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_profile 
			 		WHERE
			 			code = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Retrieve agency logo on ag_id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_agency_data($p_agency_user_id){
		$v_query = "SELECT
						logo
			 		FROM 
			 			" . $this->get_db_table_prefix() . "agency 
			 		WHERE
			 			ag_id = '".\U::safe_sql_string($p_agency_user_id)."'
		";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		if( isset($v_locations_data) ) {
			if( isset($v_locations_data[0]) ) {
				$v_locations_data = $v_locations_data[0];
			}
		}
		return $v_locations_data;
	}
	/**
	 * Retrieve location address,logo on id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_locations_data($p_location_id){
		$v_query = "SELECT
						address,logo
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			id = '".\U::safe_sql_string($p_location_id)."'
		";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		if( isset($v_locations_data) ) {
			if( isset($v_locations_data[0]) ) {
				$v_locations_data = $v_locations_data[0];
			}
		}
		return $v_locations_data;
	}
	/**
	 * Check duplication on  ticket_profile name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_name_duplication($p_user_role){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_profile 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			_rec_status = \"SHOW\"
		";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on  ticket_profile code for edit except current
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_duplication_edit($p_user_role,$p_primary_table_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_profile 
			 		WHERE
			 			code = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check duplication on  ticket_profile name for edit except current
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_name_duplication_edit($p_user_role,$p_primary_table_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_profile 
			 		WHERE
			 			name = '".\U::safe_sql_string($p_user_role)."'
			 		AND 
			 			id != '".\U::safe_sql_string($p_primary_table_id)."'
			 		AND 
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Retrieve locations on agency_id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_agency_locations($p_agency_id,$p_restriction=NULL){
		if( isset($p_agency_id) && $p_agency_id != '' ) {
			$v_col_name = "id";
			$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "locations 
				 		WHERE
				 			agency_id = '".\U::safe_sql_string($p_agency_id)."'
				 			".$v_location_condition."
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);
			return $v_locations_data;
		}
	}
	/**
	 * Check Ticket name duplication on template_name in ticket_template
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_name_duplication($p_ticket_name){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_template 
			 		WHERE
			 			ticket_name = '".\U::safe_sql_string($p_ticket_name)."'
			 		AND
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check Ticket Name duplication on Edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_name_duplication_edit($p_ticket_name,$p_ticket_id){
		$v_query = "SELECT
						COUNT(*) as rows_found
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_template 
			 		WHERE
			 			ticket_name = '".\U::safe_sql_string($p_ticket_name)."'
			 		AND 
			 			id != '".\U::safe_sql_string($p_ticket_id)."'
			 		AND
			 			_rec_status = \"SHOW\"
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_locations_data[0]['rows_found']) ) {
			$v_rows_count =  $v_locations_data[0]['rows_found'];
		}
		return $v_rows_count;
	}
	/**
	 * Check Module Permissions
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_permission($p_permissions_name, $p_module_name=NULL) {
		$v_module = "";
		$permissions_query = "";
		$v_module_name = \E::get('MOONLIGHT_CURRENT_COMPONENT');
		if( isset($p_module_name) && $p_module_name != "" ) {
			$v_module_name = $p_module_name;
		}
		$p_logged_in_user_role = \E::get_session('logged_in_user_role');
		$p_logged_in_user_type = \E::get_session('logged_in_user_type');
		$result = FALSE;
		if( isset($p_logged_in_user_role) && $p_logged_in_user_role != "" ) {
			if( isset($p_logged_in_user_type) && $p_logged_in_user_type != "" ) {
				if( isset($p_permissions_name) && $p_permissions_name != "" ) {
					if( isset($v_module_name) && $v_module_name != "" ) {
						$v_query = "SELECT
							id
				 		FROM 
				 			" . $this->get_db_table_prefix() . "module 
				 		WHERE
				 			module_name_slug = '".\U::safe_sql_string($v_module_name)."'
				 		";
						$v_module_id = $this->co_db_root->execute_query($v_query);	
						if( isset($v_module_id) ) {
							if( $v_module_id != '' ) {
								if( isset($v_module_id[0]['id']) && $v_module_id[0]['id'] != "" ) {
									$v_module = $v_module_id[0]['id'];
									if( isset($v_module) && $v_module != "" ) {
										$v_table_name = $this->get_db_table_prefix()."module_access";
										if( $p_permissions_name == "add" ) {
											$permissions_query = " AND ".$v_table_name.".add = '1' ";
										} else if( $p_permissions_name == "edit" ) {
											$permissions_query = " AND ".$v_table_name.".edit = '1' ";
										} else if( $p_permissions_name == "view" ) {
											$permissions_query = " AND ".$v_table_name.".view = '1' ";
										} else if( $p_permissions_name == "delete" ) {
											$permissions_query = " AND ".$v_table_name.".delete = '1' ";
										}
										if( $permissions_query != "" ) {
											$v_query = "SELECT
												COUNT(*) as result
									 		FROM 
									 			" . $this->get_db_table_prefix() . "module_access 
									 		WHERE
									 			role_id = '".\U::safe_sql_string($p_logged_in_user_role)."'
									 		AND
									 			module_id = '".\U::safe_sql_string($v_module)."'
									 		AND 
									 			role_type = '".\U::safe_sql_string($p_logged_in_user_type)."'
									 			".$permissions_query."
											";
											$v_permissions_get = $this->co_db_root->execute_query($v_query);	
											if( isset($v_permissions_get[0]['result']) && $v_permissions_get[0]['result'] == 1 ) {
												return TRUE;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	/**
	 * Get Code table Values By Key
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_code_table_data($p_key_value){	
		if( isset($p_key_value) ) {
			$v_query = "SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "code_table 
				WHERE
					_rec_status = \"SHOW\"
				AND
					for_module = '".\U::safe_sql_string($p_key_value)."'
			";
			return $this->co_db_root->execute_query($v_query);
		}
	}
	/**
	 * GET CATEGORIES AGAINST LOCATION ID
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_categories_against_locations($p_location_id){
		$v_query = "SELECT
						*
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_category 
			 		WHERE
			 			location = '".\U::safe_sql_string($p_location_id)."'
			 ";
		$v_category_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_category_data) ) {
			$v_rows_count =  $v_category_data;
		}
		return $v_rows_count;
	}
	/**
	 * GET TICKET TYPES AGAINST LOCATIONS
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_category_types($p_location_id,$p_category_type_id){
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($this->get_db_table_prefix()."ticket_category.agency");
		$v_query = "SELECT
						".$this->get_db_table_prefix()."ticket_category.id as category_id,
					    ".$this->get_db_table_prefix()."ticket_category.name as category_name,
					    ".$this->get_db_table_prefix()."ticket_category.category_type_key as category_category_type_key,
					    ".$this->get_db_table_prefix()."ticket_profile.id as profile_id,
					    ".$this->get_db_table_prefix()."ticket_profile.price as profile_price,
					    ".$this->get_db_table_prefix()."ticket_profile.name as profile_name
					FROM
						".$this->get_db_table_prefix()."ticket_category
					INNER JOIN
						".$this->get_db_table_prefix()."ticket_profile
					ON
					    ".$this->get_db_table_prefix()."ticket_profile.category = ".$this->get_db_table_prefix()."ticket_category.id
					AND
						".$this->get_db_table_prefix()."ticket_profile.location = '".\U::safe_sql_string($p_location_id)."'
					AND
						".$this->get_db_table_prefix()."ticket_category._rec_status = \"SHOW\" 
					AND
						".$this->get_db_table_prefix()."ticket_profile._rec_status = \"SHOW\" 
						".$v_agency_condition."
					AND
						".$this->get_db_table_prefix()."ticket_category.category_type_key = '".$p_category_type_id."'
					";
		$v_category_data = $this->co_db_root->execute_query($v_query);	
		return $v_category_data;
	}
	/**
	 * GET TICKET PROFILE DATA AGAINST CATEGORY
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_profile_against_category($p_category_id){
		$v_query = "SELECT
						*
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_profile 
			 		WHERE
			 			category = '".\U::safe_sql_string($p_category_id)."'
			 ";
		$v_profile_data = $this->co_db_root->execute_query($v_query);	
		return $v_profile_data;
	}
	/**
	 * GET TICKET PROFILE DATA AGAINST CATEGORY
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_template_against_category($p_profile_id){
		$v_query = "SELECT
						COUNT(*) as temple_exists
			 		FROM 
			 			" . $this->get_db_table_prefix() . "ticket_template 
			 		WHERE
			 			_rec_status = \"SHOW\" 
			 		AND
			 			ticket_name = '".\U::safe_sql_string($p_profile_id)."'
			 ";
		$v_profile_data = $this->co_db_root->execute_query($v_query);	
		$v_rows_count = 0;
		if( isset($v_profile_data[0]['temple_exists']) ) {
			$v_rows_count =  $v_profile_data[0]['temple_exists'];
		}
		return $v_rows_count;
	}
	/**
	 * Check Ticket Transaction Sequence
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_sequence_transaction($p_select_location=NULL){
		$v_sequence_number = "";
		$v_location_code = "";
		$v_query = "SELECT
						key_value
			 		FROM 
			 			" . $this->get_db_table_prefix() . "code_table 
			 		WHERE
			 			key_name = '".\U::safe_sql_string('ticket_year')."'
			 		";
		$v_profile_data = $this->co_db_root->execute_query($v_query);	
		if( isset($v_profile_data[0]['key_value']) && $v_profile_data[0]['key_value'] != "" ) {
			$v_eploded_sequence = explode("-",$v_profile_data[0]['key_value']);
			if( isset($v_eploded_sequence[0]) && $v_eploded_sequence[0] != '' ) {
				if( date("Y") == $v_eploded_sequence[0] ) {
					if( isset($v_eploded_sequence[1]) && $v_eploded_sequence[1] != '' ) {
						$v_sequence_number =  TICKET_SEQUENCE_YEAR.str_pad($v_eploded_sequence[1] + 1, 5, 0, STR_PAD_LEFT);
						$v_sequence_number_db =  TICKET_SEQUENCE_YEAR."-".str_pad($v_eploded_sequence[1] + 1, 5, 0, STR_PAD_LEFT);
						if( $v_sequence_number && $v_sequence_number != '' ) {
							$v_query = "UPDATE
											" . $this->get_db_table_prefix() . "code_table
										SET
											key_value = '".\U::safe_sql_string($v_sequence_number_db)."'
								 		WHERE
								 			key_name = '".\U::safe_sql_string('ticket_year')."'
							";
							$this->co_db_root->execute_query($v_query);	
						}
					}
				} else if( date("Y") != $v_eploded_sequence[0] ) {
					$v_ticket_sequence = TICKET_SEQUENCE_YEAR."-".TICKET_SEQUENCE_START;
					$v_query = "UPDATE
									" . $this->get_db_table_prefix() . "code_table
								SET
									key_value = '".\U::safe_sql_string($v_ticket_sequence)."'
						 		WHERE
						 			key_name = '".\U::safe_sql_string('ticket_year')."'
					";
					$v_sequence_updated = $this->co_db_root->execute_query($v_query);	
					if( $v_sequence_updated && $v_sequence_updated != "" ) {
						$v_sequence_number = TICKET_SEQUENCE_YEAR.TICKET_SEQUENCE_START;
					}
				}
				if( $v_sequence_number != "" ) {
					$v_cond['usr_id'] = \E::get_session('usr_id');
					$v_check_info = \E::get('obj_system_module')->user_get($v_cond);
					if( isset($v_check_info) ) {
						if( $v_check_info != '' ) {
							if( isset($v_check_info['location']) && $v_check_info['location'] != '' ) {
								$v_location_data = \E::get( 'obj_curr_module')->location_get_by_id($v_check_info['location']);
								if( isset($v_location_data['code']) && $v_location_data['code'] != '' ) {
									$v_location_code = $v_location_data['code'];
								}
							}
							if( $v_location_code == '' ) {
								$v_location_data = \E::get( 'obj_curr_module')->location_get_by_id($p_select_location);
								if( isset($v_location_data['code']) && $v_location_data['code'] != '' ) {
									$v_location_code = $v_location_data['code'];
								}
							}
							$v_agency_data = \E::get('obj_curr_module')->agency_get_by_id( \E::get_session("c_user_agency_id") );
							if( isset($v_agency_data['ag_code']) && $v_agency_data['ag_code'] != '' ) {
								$v_agency_code = $v_agency_data['ag_code'];
								return $v_agency_code.$v_location_code.$v_sequence_number;
							}
						}
					}
				}
			}
		}
	}
	/**
	 * Check Ticket Sequence
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_sequence($p_qty){
		$v_sequence_number = "";
		$v_query = "SELECT
						key_value
			 		FROM 
			 			" . $this->get_db_table_prefix() . "code_table 
			 		WHERE
			 			key_name = '".\U::safe_sql_string('reference_number')."'
			 ";
		$v_profile_data = $this->co_db_root->execute_query($v_query);	
		if( isset($v_profile_data[0]['key_value']) && $v_profile_data[0]['key_value'] != "" ) {
			$v_eploded_sequence = explode("-",$v_profile_data[0]['key_value']);
			if( isset($v_eploded_sequence[0]) && $v_eploded_sequence[0] != '' ) {
				if( date("Y") == $v_eploded_sequence[0] ) {
					if( isset($v_eploded_sequence[1]) && $v_eploded_sequence[1] != '' ) {
						$v_sequence_number =  TICKET_SEQUENCE_YEAR.str_pad($v_eploded_sequence[1] + 1, 5, 0, STR_PAD_LEFT);
						$v_sequence_number_db =  TICKET_SEQUENCE_YEAR."-".str_pad($v_eploded_sequence[1] + $p_qty, 5, 0, STR_PAD_LEFT);
						if( $v_sequence_number && $v_sequence_number != '' ) {
							$v_query = "UPDATE
											" . $this->get_db_table_prefix() . "code_table
										SET
											key_value = '".\U::safe_sql_string($v_sequence_number_db)."'
								 		WHERE
								 			key_name = '".\U::safe_sql_string('reference_number')."'
							";
							$this->co_db_root->execute_query($v_query);	
						}
					}
				} else if( date("Y") != $v_eploded_sequence[0] ) {
					$v_ticket_sequence = TICKET_SEQUENCE_YEAR."-".TICKET_SEQUENCE_START;
					$v_query = "UPDATE
									" . $this->get_db_table_prefix() . "code_table
								SET
									key_value = '".\U::safe_sql_string($v_ticket_sequence)."'
						 		WHERE
						 			key_name = '".\U::safe_sql_string('reference_number')."'
					";
					$v_sequence_updated = $this->co_db_root->execute_query($v_query);	
					if( $v_sequence_updated && $v_sequence_updated != "" ) {
						$v_sequence_number = TICKET_SEQUENCE_YEAR.TICKET_SEQUENCE_START;
					}
				}
				if( $v_sequence_number != "" ) {
					$v_agency_data = \E::get('obj_curr_module')->agency_get_by_id( \E::get_session("c_user_agency_id") );
					if( isset($v_agency_data['ag_code']) && $v_agency_data['ag_code'] != '' ) {
						$v_agency_code = $v_agency_data['ag_code'];
						return $v_agency_code.$v_sequence_number;
					}
				}
			}
		}
	}
	/**
	 * Get Location Per day
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_location_per_day($p_select_location){
		$v_sequence_number = "";
		$v_query = "SELECT
						total_ticket_per_day
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			id = '".\U::safe_sql_string($p_select_location)."'
			 ";
		$v_per_day = $this->co_db_root->execute_query($v_query);	
		return $v_per_day;
	}
	/**
	 * Get Location Per day USED
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_location_per_day_used($p_select_location){
		$v_sequence_number = "";
		$v_query = "SELECT
						COUNT(*) as total_per_day_ticket_used
					FROM
						" . $this->get_db_table_prefix() . "sales_transaction
					INNER JOIN
						" . $this->get_db_table_prefix() . "tickets
					ON
						" . $this->get_db_table_prefix() . "sales_transaction.id = " . $this->get_db_table_prefix() . "tickets.sales_transaction_id 
					WHERE
						" . $this->get_db_table_prefix() . "sales_transaction.location_id = '".\U::safe_sql_string($p_select_location)."'
					AND
						" . $this->get_db_table_prefix() . "sales_transaction.transaction_date >= '".date("Y-m-d 00:00:00")."'
					AND
						" . $this->get_db_table_prefix() . "sales_transaction.transaction_date <= '".date("Y-m-d 23:59:59")."'
					AND
						" . $this->get_db_table_prefix() . "sales_transaction._rec_status = \"SHOW\"
					ORDER BY
						" . $this->get_db_table_prefix() . "sales_transaction.location_id ASC
			 ";
		$v_per_day_used = $this->co_db_root->execute_query($v_query);	
		return $v_per_day_used;
	}
	/**
	 * DELETE LOCATION LOGO
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_delete_uploaded_logo($p_master_id){
		if( $p_master_id != "" ) {
			$v_query = "UPDATE
				 			" . $this->get_db_table_prefix() . "att
				 		SET
				 			_rec_status = \"DELETED\"
				 		WHERE
				 			master_id = '".\U::safe_sql_string($p_master_id)."'
				 		ORDER BY
				 			att_id DESC
				 		LIMIT
				 			1
					";
			$this->co_db_root->execute_query($v_query);	
		}
	}
}
?>