<?php
namespace moonlight\eticket;
class eticket_buy_ticket {
	private $co_db;
	public function __construct( $p_co_db ){
		$this->co_db = $p_co_db;
	}
	public function __destruct(){
		unset($this->co_db);
	}
	/**
	 * INSERT TICKET BUY TRANSACTION
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_transaction_save( $p_data ){
		return $this->co_db->buy_ticket_transaction_save( $p_data );
	}
	/**
	 * INSERT TICKET BUY
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_save( $p_data ){
		return $this->co_db->buy_ticket_save( $p_data );
	}
	/**
	 * INSERT TICKET DEMOGRAPHIC
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_demographic_info( $p_data ){
		return $this->co_db->buy_ticket_demographic_info( $p_data );
	}
	/**
	 * Reprint Ticket
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_reprint_ticket($p_sales_transaction_id=NULL){
		return $this->co_db->buy_ticket_reprint_ticket($p_sales_transaction_id);
	}
	/**
	 * Reprint Ticket Receipts
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_reprint_ticket_receipts($p_sales_transaction_id=NULL){
		return $this->co_db->buy_ticket_reprint_ticket_receipts($p_sales_transaction_id);
	}
	/**
	 * Update Email Status
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_update_email_status($p_sales_transaction_id, $p_receipt_image_id, $p_tickets_image_id){
		return $this->co_db->buy_ticket_update_email_status($p_sales_transaction_id, $p_receipt_image_id, $p_tickets_image_id);
	}
	/**
	 * Get Code table Value By Key Name
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_get_code_table_vallue_by_key_name($p_key_name=NULL){
		return $this->co_db->buy_ticket_get_code_table_vallue_by_key_name($p_key_name);
	}
	/**
	 * Ticket Listing
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_get_listing($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		return $this->co_db->buy_ticket_get_listing($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length);
	}
	/**
	 * Ticket Cancellation Process
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_cancellation_process($p_transaction_id){
		return $this->co_db->buy_ticket_cancellation_process($p_transaction_id);
	}
	/**
	 * Ticket Cancellation Process
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_cancell_reject_process($p_transaction_id, $p_authorization_status,$p_location_admin_user_id,$p_refund_transaction_reference_no=NULL,$p_refund_transaction_flow_no=NULL){
		return $this->co_db->buy_ticket_cancell_reject_process($p_transaction_id, $p_authorization_status,$p_location_admin_user_id,$p_refund_transaction_reference_no,$p_refund_transaction_flow_no);
	}
	/**
	 * CHECK TANSACTION NUMBER ALREADY EXISTS IN THE SYSTEM
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_check_transaction_number_validity($p_transaction_number){
		return $this->co_db->buy_ticket_check_transaction_number_validity($p_transaction_number);
	}
	/**
	 * GET TRANSACTION DETAILS BY TRANSACTION PRIMARY ID
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_get_transaction_details_by_primary_id($p_transaction_number){
		return $this->co_db->buy_ticket_get_transaction_details_by_primary_id($p_transaction_number);
	}
	/**
	 * GET TRANSACTION DETAILS BY TRANSACTION REFERENCE NUMBER
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_get_transaction_details_by_reference_number($p_transaction_reference_number){
		return $this->co_db->buy_ticket_get_transaction_details_by_reference_number($p_transaction_reference_number);
	}
	/**
	 * GET TRANSACTION DETAILS BY TRANSACTION REFERENCE NUMBER
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_check_number_of_tickets_allowed($_post_data){
		$respnose = array();
		$limit_reached = 0;
		$v_used_tickets = 0;
		$v_total_qty_added = 0;
		$v_location_per_day_limit = 0;
		foreach ($_post_data['selected_quantity_list'] as $v_key => $v_each_profile_data) {
			 $v_total_qty_added += $v_each_profile_data['quantity'];
		}
		$v_select_location = $_post_data['select_location'];
		$v_location_per_day = \E::get('obj_curr_module')->ajax_validation_get_location_per_day($v_select_location);
		$v_location_per_day_used = \E::get('obj_curr_module')->ajax_validation_get_location_per_day_used($v_select_location);
		if( isset($v_location_per_day[0]['total_ticket_per_day']) && $v_location_per_day[0]['total_ticket_per_day'] != '' ) {
			$v_location_per_day_limit = $v_location_per_day[0]['total_ticket_per_day'];
		}
		$v_location_per_day_limit_used = $v_total_qty_added;
		if( isset($v_location_per_day_used[0]['total_per_day_ticket_used']) && $v_location_per_day_used[0]['total_per_day_ticket_used'] != '' ) {
			$v_used_tickets = $v_location_per_day_used[0]['total_per_day_ticket_used'];
			$v_location_per_day_limit_used += $v_location_per_day_used[0]['total_per_day_ticket_used'];
		}
		if( ($v_location_per_day_limit == 0) || ($v_location_per_day_limit < $v_location_per_day_limit_used) ) {
			$limit_reached = 1;
		}
		$respnose["limit_reached"] = $limit_reached;
		$respnose["v_used_tickets"] = $v_used_tickets;
		$respnose["v_total_qty_added"] = $v_total_qty_added;
		$respnose["v_location_per_day_limit"] = $v_location_per_day_limit;
		return $respnose;
	}
	/**
	 * GET MERCHANT ID
	 *
	 * @access public
	 * @return
	 */
	public function buy_ticket_get_merchant_id($p_location_id){
		return $this->co_db->buy_ticket_get_merchant_id($p_location_id);
	}
}
?>