<?php
namespace moonlight\eticket;
class eticket_ticket_profile_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Insert new ticket profile save
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_save($p_data) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				$v_query = "INSERT INTO
						" . $this->get_db_table_prefix() . "ticket_profile
					SET
						code = '".\U::safe_sql_string($p_data['code'])."',
						name = '".\U::safe_sql_string($p_data['name'])."',
						category = '".\U::safe_sql_string($p_data['category'])."',
						agency = '".\U::safe_sql_string($p_data['agency'])."',
						price = '".\U::safe_sql_string($p_data['price'])."',
						location = '".\U::safe_sql_string($p_data['location'])."',
						remarks = '".\U::safe_sql_string($p_data['remarks'])."',
						_rec_status = '".\U::safe_sql_string($p_data['_rec_status'])."',
						_rec_created_by = '".\U::safe_sql_string($p_data['_rec_created_by'])."',
						_rec_created_on = '".\U::safe_sql_string($p_data['_rec_created_on'])."',
						_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
						_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
					";
				$v_role_add = $this->co_db_root->execute_query($v_query);
				if ($v_role_add) {
					return $v_role_id = $this->co_db_root->get_last_insert_id();
				}
			}
		}
	}
	/**
	 * Update ticket profile
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_update($p_data, $p_id_to_update_table) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				if( isset($p_id_to_update_table) && $p_id_to_update_table != '' ) {
					$v_query = "UPDATE
							" . $this->get_db_table_prefix() . "ticket_profile
						SET
							code = '".\U::safe_sql_string($p_data['code'])."',
							name = '".\U::safe_sql_string($p_data['name'])."',
							category = '".\U::safe_sql_string($p_data['category'])."',
							agency = '".\U::safe_sql_string($p_data['agency'])."',
							price = '".\U::safe_sql_string($p_data['price'])."',
							location = '".\U::safe_sql_string($p_data['location'])."',
							remarks = '".\U::safe_sql_string($p_data['remarks'])."',
							_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
							_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
						WHERE
							id = '" . \U::safe_sql_string($p_id_to_update_table) . "'
						";
					return $this->co_db_root->execute_query($v_query);
				}
			}
		}
	}
	/**
	 * Get ticket profile by id
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_get_by_id($p_profile_id) {
		if( isset($p_profile_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "ticket_profile 
				 		WHERE
				 			id = '".\U::safe_sql_string($p_profile_id)."'
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			if( isset($v_locations_data) && $v_locations_data != '' ) {
				return $v_locations_data[0];
			}
		}
	}/**
	 * Get ticket profile by Category ID
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_get_by_category_id($p_category_id,$p_location_id) {
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		if( isset($p_category_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "ticket_profile 
				 		WHERE
				 			_rec_status = \"SHOW\" 
				 		AND
				 			category = '".\U::safe_sql_string($p_category_id)."'
				 		AND
				 			location = '".\U::safe_sql_string($p_location_id)."'
				 			".$v_agency_condition."
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			return $v_locations_data;
		}
	}
	/**
	 * Soft delete ticket profile by id
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_delete( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "ticket_profile 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( \E::get_session('usr_id') ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/**
	 * Retrieve ticket profile listing with filters
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name = "location";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_search_by_ticket_name = $p_cond['search_by_ticket_name']; 
		$v_search_by_ticket_name_search = "";
		if( $v_search_by_ticket_name != '' ) {
			$v_search_by_ticket_name_search = " AND ( name LIKE '%" . \U::safe_sql_string($v_search_by_ticket_name) . "%')";
 		}
		$v_ticket_name_filter = $p_cond['ticket_name_filter'];
		$v_ticket_name_filter_search = "";
		if( $v_ticket_name_filter != '' ) {
			$v_ticket_name_filter_search = " AND ( id IN('" . implode ( "', '", \U::safe_sql_string($v_ticket_name_filter)) . "') ) ";
 		}
		$v_location_filter = $p_cond['location_filter'];
		$v_location_search = "";
		if( $v_location_filter != '' ) {
			$v_location_search = " AND ( location IN('" . implode ( "', '", \U::safe_sql_string($v_location_filter)) . "') ) ";
 		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
 		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
 		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "ticket_profile 
				WHERE 
				 	_rec_status = \"SHOW\"
				 	".$v_search_by_ticket_name_search." 
				 	".$v_location_condition." 
				 	".$v_ticket_name_filter_search." 
				 	".$v_agency_condition." 
				 	".$v_location_search." 
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve ticket category list
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_category_list(){
		$v_query = "SELECT *
				 FROM " . $this->get_db_table_prefix() . "ticket_category";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Retrieve location list
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_location_data($p_location_id){
		if( isset($p_location_id) ) {
			$v_query = "SELECT
							*
				 			FROM
				 				" . $this->get_db_table_prefix() . "locations
				 			WHERE
				 				id = '".\U::safe_sql_string($p_location_id)."'
				 		";
			return $this->co_db_root->execute_query($v_query);
		}
	}
	/**
	 * Retrieve ticket category list
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_category_data($p_category_id){
		if( isset($p_category_id) ) {
			$v_query = "SELECT
							*
				 			FROM
				 				" . $this->get_db_table_prefix() . "ticket_category
				 			WHERE
				 				id = '".\U::safe_sql_string($p_category_id)."'
				 		";
			return $this->co_db_root->execute_query($v_query);
		}
	}
	/**
	 * Retrieve ticket category list by agency
	 *
	 * @access public
	 * @return
	 */
	public function ticket_profile_category_list_by_agency(){
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition("agency");
		$v_query = "SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "ticket_category
				WHERE
					_rec_status = \"SHOW\"
					".$v_agency_condition."
				";
		return $this->co_db_root->execute_query($v_query);
	}
}
?>
