<?php
namespace moonlight\eticket;
class eticket_user_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/*
	 * Function to get user acl
	 */
	public function user_acl_get( $p_usr_id ){
		// QUERY - acl group table
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix() . "acl_user_group 
					WHERE _rec_status = \"SHOW\" 
					AND usr_id=?
					";
		$this->co_db_root->set_prepare_statement($v_query);
		$v_param[0]['data_type'] = 'str';
		$v_param[0]['data'] =  $p_usr_id;
		$this->co_db_root->bind_param($v_param);
		$v_result = $this->co_db_root->execute_statement();
		if( $v_result && is_array($v_result) ){
			$v_result[0]['_rec_modified_on'] = $this->co_db_root->__to_display_date($v_result[0]['_rec_modified_on']);
		}
		return $v_result;
	}
	/*
	 * Function to check user group duplication
	 */
	public function user_group_check_duplicate($p_field_name=NULL, $p_field_value=NULL, $p_current_usr_id=NULL){
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix() . "user 
					WHERE '" . \U::safe_sql_string($p_field_name) . "'  = '" . \U::safe_sql_string($p_field_value) . "'
					AND usr_id != '" . \U::safe_sql_string($p_current_usr_id) . "'
					AND
						_rec_status = \"SHOW\" 
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/*
	 * Function to check user field duplication
	 */
	public function user_check_duplicate_field($p_field_name=NULL, $p_field_value=NULL, $p_table_name=NULL){
		$v_query = 	"SELECT 
					*
					FROM " . $this->get_db_table_prefix() .$p_table_name. " 
					WHERE '" . \U::safe_sql_string($p_field_name) . "'  = '" . \U::safe_sql_string($p_field_value) . "'
					AND _rec_status = \"SHOW\" 
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/*
	 * Function to retrieve user data based on id
	 */
	public function user_get_data($p_userid=NULL){
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix() . "user 
					WHERE usr_id = '" . \U::safe_sql_string($p_userid) . "'
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/*
	 * Function to retrieve user specific agency data
	 */
	public function user_get_aganecy_data($p_agency_id=NULL){
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix() . "agency 
					WHERE ag_id = '" . \U::safe_sql_string($p_agency_id) . "' 
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	// extra function for multiple access right
	public function user_acl_form_get( $p_usr_id, $p_value ){
		$v_cond = "";
		if( isset($p_value['usr_acl_id']) && $p_value['usr_acl_id'] != '' ){
			$v_cond .= " AND usr_acl_id=? ";
		}
		// QUERY - acl group table
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix() . "acl_user_group 
					WHERE _rec_status = \"SHOW\" 
					AND usr_id=?
					{$v_cond}
					";
		$this->co_db_root->set_prepare_statement($v_query);
		$v_param[0]['data_type'] = 'str';
		$v_param[0]['data'] =  $p_usr_id;
		$v_param_count = 1;
		if( isset($p_value['usr_acl_id']) && $p_value['usr_acl_id'] != '' ){
			$v_param[$v_param_count]['data_type'] = 'int';
			$v_param[$v_param_count]['data'] =  $p_value['usr_acl_id'];
			$v_param_count++;
		}
		$this->co_db_root->bind_param($v_param);
		$v_result = $this->co_db_root->execute_statement();
		if( $v_result && is_array($v_result) ){
			$v_result[0]['_rec_modified_on'] = $this->co_db_root->__to_display_date($v_result[0]['_rec_modified_on']);
		}
		return $v_result;
	}
	/*
	 * Function to retrieve the list of user acl group
	 */
	public function user_acl_list( $p_order=NULL, $p_start = NULL, $p_num_of_rec = NULL, $p_value = NULL ){
		$v_cond = '';
		// search keyword
		$v_cond .= " AND u.usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\" ";
		if( !empty($p_value['search']) ){
			$v_cond .=" AND ( b.site_name=\"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\" OR l.group_name=\"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\" ) ";
		}
		// ORDER BY - Coding
		$v_order_by = '';
		if( $p_order !== NULL ){
			foreach( $p_order as $v_value ){
				if( $v_order_by == '' ) {
					$v_order_by = ' ORDER BY '.\U::safe_sql_string($v_value['order_by']).' '.\U::safe_sql_string($v_value['sort_by']);
				} else {
					$v_order_by .= ', ' . \U::safe_sql_string($v_value['order_by']) . ' ' .\U::safe_sql_string($v_value['sort_by']); 
				}
			}
		}
		// LIMIT - Coding
		$v_limit = '';
		if( $p_start !== NULL && $p_num_of_rec !== NULL ){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
		}
		// QUERY - Coding
		$v_query = 	"SELECT 
						u.usr_acl_id,
						u.usr_id,
						b.site_name,
						l.group_name
					FROM " . $this->get_db_table_prefix() . "acl_user_group u
					LEFT JOIN " . $this->get_db_table_prefix() . "acl_group l
					ON u.group_id = l.group_id
					LEFT JOIN " . $this->get_db_table_prefix() . "billing_site b
					ON b._rec_status = \"SHOW\"
					WHERE u._rec_status = \"SHOW\"
					{$v_cond}
					" . $v_order_by . $v_limit;
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/*
	* Function to count the total of user acl group
	*/
	public function user_acl_list_total( $p_value ){
		$v_cond = '';
		$v_cond .= " AND u.usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\" ";
		// QUERY - Coding
		$v_query = 	"SELECT 
						COUNT(u.usr_acl_id) AS 'total_rec'
					FROM " . $this->get_db_table_prefix() . "acl_user_group u
					LEFT JOIN " . $this->get_db_table_prefix() . "acl_group l
					ON u.group_id = l.group_id
					WHERE u._rec_status = \"SHOW\"
					{$v_cond}";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result[0]['total_rec'];
	}
	/*
	 * Function to add user acl
	 */
	public function user_acl_add( $p_value ){
		$v_query = 	"REPLACE INTO 
					" . $this->get_db_table_prefix() . "acl_user_group(
						usr_id,
						group_id,
						_rec_created_on,
						_rec_created_by,
						_rec_modified_on,
						_rec_modified_by,
						_rec_status
					)VALUE(
						\"" . \U::safe_sql_string( $p_value['usr_id'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['usr_group'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						\"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
					)";
		$v_result = $this->co_db_root->execute_query($v_query);
		
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/*
	 * Function to update user acl details
	 */
	public function user_acl_edit( $p_value ){
		$v_update = "";
		if( isset($p_value['usr_group']) && $p_value['usr_group'] != "" ){
			$v_update .= " group_id = \"" . \U::safe_sql_string( $p_value['usr_group'] ) . "\", ";
		}
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "acl_user_group 
					SET
						{$v_update}
						_rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						_rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
					WHERE 
						usr_id = \"" . \U::safe_sql_string( $p_value['usr_id'] ) . "\"
						AND _rec_status = \"SHOW\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/*
	 * Function to soft delete user group
	 */
	public function user_acl_soft_del( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "acl_user_group 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						usr_id = \"" . \U::safe_sql_string( $p_value['usr_id'] ) . "\"
						AND usr_acl_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/*
	 * Function to hard delete user group
	 */
	public function user_acl_hard_del( $p_value ){
		$v_query = 	"DELETE FROM 
						" . $this->get_db_table_prefix() . "acl_user_group 
					WHERE 
						usr_id = \"" . \U::safe_sql_string( $p_value['usr_id'] ) . "\"
						AND usr_acl_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/*
	 * Function to check user field duplication on edit
	 */
	public function user_check_duplicate_field_edit($p_field_name=NULL, $p_field_value=NULL, $p_table_name=NULL, $p_table_primary_id=NULL, $p_primary_key_name=NULL){
		$v_primaay_field_name = " AND id !=  '" . \U::safe_sql_string($p_table_primary_id) . "' ";
		if( $p_primary_key_name != '' ) {
			$v_primaay_field_name = " AND '" . \U::safe_sql_string($p_primary_key_name) . "' != '" . \U::safe_sql_string($p_table_primary_id) . "'";
		}
		$p_table_name =  \U::safe_sql_string($p_table_name);
		$v_query = 	"SELECT 
						*
					FROM " . $this->get_db_table_prefix().$p_table_name."
					WHERE '" . \U::safe_sql_string($p_field_name) . "'  = '" . \U::safe_sql_string($p_field_value) . "'
					".$v_primaay_field_name." 
					AND
					_rec_status = \"SHOW\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		return $v_result;
	}
	/*
	 * Function to retrieve user role data
	 */
	public function user_get_role_data($p_role_id){
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user_roles 
				WHERE 
				 	_rec_status = \"SHOW\"
				AND
					id = '" . \U::safe_sql_string($p_role_id) . "'
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/*
	 * Function to retrieve user listing with filters
	 */
	public function user_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_col_name = "location";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_usr_short_name = $p_cond['user_name']; 
		$v_location_name_code_search = "";
		if( $v_usr_short_name != '' ) {
			$v_location_name_code_search = " AND ( usr_short_name LIKE '%" . \U::safe_sql_string($v_usr_short_name) . "%')	 ";
		}
		$v_agency_filter_data = $p_cond['agency_filter_data'];
		$v_agency_search = "";
		if( $v_agency_filter_data != '' ) {
			$v_agency_search = " AND ( agency IN('" . implode ( "', '", \U::safe_sql_string($v_agency_filter_data)) . "') ) ";
		}
		$v_status_filter_data = $p_cond['status_filter_data'];
		$v_status_search = "";
		if( $v_status_filter_data != '' ) {
			$v_status_search = " AND ( active_inactive_status IN('" . implode ( "', '", \U::safe_sql_string($v_status_filter_data)) . "') ) ";
 		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
 		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
 		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user 
				WHERE 
				 	_rec_status = \"SHOW\"
				 AND 
				 	role != 0
				 	".$v_location_name_code_search." 
				 	".$v_location_condition." 
				 	".$v_status_search." 
				 	".$v_agency_search." 
				 	".$v_agency_condition."
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	public function user_get_location_agency_wise($p_location_id=NULL) {
		$v_location_condition_ajax = " AND location != '' ";
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		if( ($p_location_id != NULL) && ($p_location_id != "") ) {
			$v_location_condition_ajax = " AND  location = '".$p_location_id."' ";
		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "user 
				WHERE 
				 	_rec_status = \"SHOW\"
				AND 
					active_inactive_status = 1
				 	".$v_agency_condition."
				 	".$v_location_condition_ajax."	
		";
		return $this->co_db_root->execute_query($v_query);
	}
	public function user_authorize_user($p_user_name,$p_user_password) {
		if( isset($p_user_name) && $p_user_name != '' ) {
			if( isset($p_user_password) && $p_user_password != '' ) {
				$v_col_name = "agency";
				$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
				
				$v_query = "
						SELECT
							count(*) as user_found,
							".$this->get_db_table_prefix() . "user .*
						FROM
							" . $this->get_db_table_prefix() . "user 
						WHERE 
						 	_rec_status = \"SHOW\"
						 	".$v_agency_condition."
						AND 
							usr_short_name = '".\U::safe_sql_string($p_user_name)."'
						AND
							usr_password = '".\U::safe_sql_string(md5($p_user_password))."'
				";
				$query_result = $this->co_db_root->execute_query($v_query);
				if( isset($query_result[0]) ) {
					return $query_result[0];
				}
			}
		}
	}
	/*
	 * Function to check user field duplication
	 */
	public function user_check_duplicate_field_user_role($p_role_name, $p_agency_id){
		if( $p_role_name != '' && $p_agency_id != '' ) {
			$v_query = 	"SELECT 
						*
							FROM " . $this->get_db_table_prefix(). "user_roles
						WHERE
							name  = '" . \U::safe_sql_string($p_role_name) . "'
						AND 
							agency_id  = '" . \U::safe_sql_string($p_agency_id) . "'
						AND
							_rec_status = \"SHOW\" 
						";
			$v_result = $this->co_db_root->execute_query($v_query);
			return $v_result;
		}
	}
	/*
	 * Function to check user field duplication
	 */
	public function user_check_duplicate_field_user_role_edit($p_role_name, $p_agency_id, $p_role_id){
		if( $p_role_name != '' && $p_agency_id != '' && $p_role_id != '' ) {
			$v_query = 	"SELECT 
						*
						FROM " . $this->get_db_table_prefix(). "user_roles
						WHERE
							name = '" . \U::safe_sql_string($p_role_name) . "'
						AND 
							agency_id = '" . \U::safe_sql_string($p_agency_id) . "'
						AND 
							id != '" . \U::safe_sql_string($p_role_id) . "'
						AND _rec_status = \"SHOW\" 
						";
			$v_result = $this->co_db_root->execute_query($v_query);
			return $v_result;
		}
	}
}
?>